package org.jeecg.modules.toolBorrowingRecord.controller;

import java.security.Security;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.qrcodeutil.utils.R;
import org.jeecg.modules.stock.entity.StockLog;
import org.jeecg.modules.stock.service.IStockLogService;
import org.jeecg.modules.system.entity.SysUser;
import org.jeecg.modules.system.util.SecurityUtil;
import org.jeecg.modules.tool.service.IToolService;
import org.jeecg.modules.toolBorrowingRecord.entity.ToolBorrowingRecord;
import org.jeecg.modules.toolBorrowingRecord.service.IToolBorrowingRecordService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.toolSheet.entity.ToolSheet;
import org.jeecg.modules.toolSheet.service.IToolSheetService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 工器具借用记录
 * @Author: jeecg-boot
 * @Date:   2025-01-15
 * @Version: V1.0
 */
@Api(tags="工器具借用记录")
@RestController
@RequestMapping("/toolBorrowingRecord")
@Slf4j
public class ToolBorrowingRecordController extends JeecgController<ToolBorrowingRecord, IToolBorrowingRecordService> {
	@Autowired
	private IToolBorrowingRecordService toolBorrowingRecordService;

	@Autowired
	private IToolSheetService toolSheetService;

	@Autowired
	private IStockLogService stockLogService;
	/**
	 * 分页列表查询
	 *
	 * @param toolBorrowingRecord
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "工器具借用记录-分页列表查询")
	@ApiOperation(value="工器具借用记录-分页列表查询", notes="工器具借用记录-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ToolBorrowingRecord>> queryPageList(ToolBorrowingRecord toolBorrowingRecord,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ToolBorrowingRecord> queryWrapper = QueryGenerator.initQueryWrapper(toolBorrowingRecord, req.getParameterMap());
		Page<ToolBorrowingRecord> page = new Page<ToolBorrowingRecord>(pageNo, pageSize);
		IPage<ToolBorrowingRecord> pageList = toolBorrowingRecordService.page(page, queryWrapper);
		if(StringUtils.isNotEmpty(toolBorrowingRecord.getToolTypeId())){
			List<ToolBorrowingRecord> records = pageList.getRecords().stream().filter(record -> {
				ToolSheet toolSheet = toolSheetService.getById(record.getToolId());
				return toolSheet != null && toolSheet.getToolId().equals(toolBorrowingRecord.getToolTypeId());
			}).toList();
			pageList.setRecords(records);
		}

		return Result.OK(pageList);
	}

	 /**
	  *   添加
	  *
	  * @param toolBorrowingRecord
	  * @return
	  */
	 @AutoLog(value = "工器具借用记录-归还")
	 @ApiOperation(value="工器具借用记录-归还", notes="工器具借用记录-归还")
	 //@RequiresPermissions("org.jeecg.modules:bu_tool_borrowing_record:add")
	 @GetMapping(value = "/return/{id}")
	 public Result<String> returnTool(@PathVariable("id")String id) {
         try {
             if(toolBorrowingRecordService.returnTool(id)){
				 return Result.OK("归还成功！");
			 }else{
				 return Result.error("归还失败");
			 }
         } catch (Exception e) {
			 return Result.error(e.getMessage());
         }

	 }

	/**
	 *   添加
	 *
	 * @param toolBorrowingRecord
	 * @return
	 */
	@AutoLog(value = "工器具借用记录-添加")
	@ApiOperation(value="工器具借用记录-添加", notes="工器具借用记录-添加")
	//@RequiresPermissions("org.jeecg.modules:bu_tool_borrowing_record:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ToolBorrowingRecord toolBorrowingRecord) {
		LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		toolBorrowingRecord.setBorrower(user.getId());
		toolBorrowingRecordService.save(toolBorrowingRecord);
//		StockLog stockLog = new StockLog();
//		stockLog.setItem(toolSheet.getId());
//		stockLog.setQuantity(Double.valueOf(toolBorrowingRecord.getCount()));
//		stockLog.setType(1);
//		stockLog.setIoType(toolBorrowingRecord.getStatus());
//		stockLogService.save(stockLog);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param toolBorrowingRecord
	 * @return
	 */
	@AutoLog(value = "工器具借用记录-编辑")
	@ApiOperation(value="工器具借用记录-编辑", notes="工器具借用记录-编辑")
	//@RequiresPermissions("org.jeecg.modules:bu_tool_borrowing_record:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ToolBorrowingRecord toolBorrowingRecord) {
		toolBorrowingRecordService.updateById(toolBorrowingRecord);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "工器具借用记录-通过id删除")
	@ApiOperation(value="工器具借用记录-通过id删除", notes="工器具借用记录-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:bu_tool_borrowing_record:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		toolBorrowingRecordService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "工器具借用记录-批量删除")
	@ApiOperation(value="工器具借用记录-批量删除", notes="工器具借用记录-批量删除")
	//@RequiresPermissions("org.jeecg.modules:bu_tool_borrowing_record:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.toolBorrowingRecordService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "工器具借用记录-通过id查询")
	@ApiOperation(value="工器具借用记录-通过id查询", notes="工器具借用记录-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ToolBorrowingRecord> queryById(@RequestParam(name="id",required=true) String id) {
		ToolBorrowingRecord toolBorrowingRecord = toolBorrowingRecordService.getById(id);
		if(toolBorrowingRecord==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(toolBorrowingRecord);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param toolBorrowingRecord
    */
    //@RequiresPermissions("org.jeecg.modules:bu_tool_borrowing_record:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ToolBorrowingRecord toolBorrowingRecord) {
        return super.exportXls(request, toolBorrowingRecord, ToolBorrowingRecord.class, "工器具借用记录");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_tool_borrowing_record:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ToolBorrowingRecord.class);
    }

	@RequestMapping(value = "/loadToolRecord/{toolId}", method = RequestMethod.GET)
	public Result<?> loadToolRecord(@PathVariable(name = "toolId") String toolId) {
		try{
			return Result.ok(toolBorrowingRecordService.loadToolRecord(toolId));
		}catch (Exception e){
			return Result.error(e.getMessage());
		}
	}
}
